
// Test communication schedules for some large arrays.

#include "ad++.h"
#include "admacros.h"

#define N 800

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  Procs2 p(2, 2) ;
  ON(p) {
    //Range x(N, p.dim(0), BLK) ;
    BlockRange x(N, p.dim(0)) ;
    //Range y(N, p.dim(1), BLK) ;
    BlockRange y(N, p.dim(1)) ;

    Array2<int> a(x, y), b(x, y) ;

    Index i(x), j(y) ;
    
    WHERE(i) {
      WHERE(j) {
        a(i, j) = i * N + j ;
      } EREWH(j) ;
    } EREWH(i) ;

    transpose(b, a) ;  // Uses `Remap' schedule internally.

    // (Recycle `a' as the comparision mask, to save space.)

    WHERE(i) {
      WHERE(j) {
        a(i, j) = b(i, j) == j * N + i ;
      } EREWH(j) ;
    } EREWH(i) ;

    if(!all(a))
      gprintf("An error has occurred\n") ;
    else {

      // Double-check with `any', in case `all' is broken.

      WHERE(i) {
	WHERE(j) {
	  a(i, j) = b(i, j) != j * N + i ;
	} EREWH(j) ;
      } EREWH(i) ;

      if(any(a))
	gprintf("An error has occurred\n") ;
      else
	gprintf("Checked OK\n") ;
    }

    // Print a sample of the transposed matrix (in case `any' and
    // `all' are both broken).

    aprintf("%8i%8N", b.sect(x.subrng(8, N / 4), y.subrng(8, (3 * N) / 4))) ;

  } NO(p) ;

  } AdlibFinalize() ;
}

